#include "usbdesc.h"

unsigned char HidReportDesc[]=
{		// HID report
	0x05, 0x01,                    // USAGE_PAGE (Generic Desktop)
	0x09, 0x06,                    // USAGE (Keyboard)
	0xa1, 0x01,                    // COLLECTION (Application)
	0x05, 0x07,                    //   USAGE_PAGE (Keyboard)
	0x19, 0xe0,                    //   USAGE_MINIMUM (Keyboard LeftControl)
	0x29, 0xe7,                    //   USAGE_MAXIMUM (Keyboard Right GUI)
	0x15, 0x00,                    //   LOGICAL_MINIMUM (0)
	0x25, 0x01,                    //   LOGICAL_MAXIMUM (1)
	0x75, 0x01,                    //   REPORT_SIZE (1)
	0x95, 0x08,                    //   REPORT_COUNT (8)
	0x81, 0x02,                    //   INPUT (Data,Var,Abs)
	0x95, 0x01,                    //   REPORT_COUNT (1)
	0x75, 0x08,                    //   REPORT_SIZE (8)
	0x81, 0x03,                    //   INPUT (Cnst,Var,Abs)
	0x95, 0x05,                    //   REPORT_COUNT (5)
	0x75, 0x01,                    //   REPORT_SIZE (1)
	0x05, 0x08,                    //   USAGE_PAGE (LEDs)
	0x19, 0x01,                    //   USAGE_MINIMUM (Num Lock)
	0x29, 0x05,                    //   USAGE_MAXIMUM (Kana)
	0x91, 0x02,                    //   OUTPUT (Data,Var,Abs)
	0x95, 0x01,                    //   REPORT_COUNT (1)
	0x75, 0x03,                    //   REPORT_SIZE (3)
	0x91, 0x03,                    //   OUTPUT (Cnst,Var,Abs)
	0x95, 0x06,                    //   REPORT_COUNT (6)
	0x75, 0x08,                    //   REPORT_SIZE (8)
	0x15, 0x00,                    //   LOGICAL_MINIMUM (0)
	0x25, 0x65,                    //   LOGICAL_MAXIMUM (101)
	0x05, 0x07,                    //   USAGE_PAGE (Keyboard)
	0x19, 0x00,                    //   USAGE_MINIMUM (Reserved (no event indicated))
	0x29, 0x65,                    //   USAGE_MAXIMUM (Keyboard Application)
	0x81, 0x00,                    //   INPUT (Data,Ary,Abs)
	0xc0                           // END_COLLECTION
};


DEVICE_DESCRIPTOR DevDesc=
{
    sizeof(DEVICE_DESCRIPTOR),			// 18 bytes long
    DESC_TYPE_DEVICE,					// device descriptor type
    0x0110,								// USB spec 1.1, LSB
    0x00,								// class code - enumarated at interface
    0x00,                               // subclass code
    0x00,                               // protocol code
    USB_MAX_EP0_SIZE,                   // max EP0 packet size
    DEVICE_VID,							// Vendor id
    DEVICE_PID,						    // Product id
    DEVICE_RELEASE,					    // Device release # (bcd)
    0x01,                               // iManufactirer
    0x02,                               // iProduct
    0x00,                               // iSerialNumber
    0x01                                // bNumConfigurations
};


CONFIG_DESCRIPTOR_DATA ConfigDescData=
{
    {     // Configuration
        sizeof(CONFIG_DESCRIPTOR),             // bLength
        DESC_TYPE_CONFIG,	 	 	           // bDescriptorType
        sizeof(CONFIG_DESCRIPTOR_DATA),		   // wTotalLength
        1,			 	 	 	               // bNumInterfaces
        0x01,	 	 	 	                   // bConfigurationValue
        0x00,	 	 	 	                   // iConfiguration
        DEV_CONFIG_ATTRIBUTES,                 // bmAttributes
        DEV_CONFIG_MAX_POWER                   // MaxPower
    },
	{		// Interface
		sizeof(INTERFACE_DESCRIPTOR),	 	// bLength
		DESC_TYPE_INTERFACE,	 	 	 	// bDescriptorType
		0x00,				 	 	 	    // bInterfaceNumber
		0x00,	 	 	 	                // bAlternateSetting
		0x01,	 	 	 	                // bNumEndpoints
		USB_HID_CLASS_CODE,	               // bInterfaceClass
		HID_SUBCLASS_BOOT,		         // bInterfaceSubClass 
		HID_INTERFACE_KEYBOARD,            // bInterfaceProtocol
		0x00                                // iInterface
	},
	{		// HID
		sizeof(HID_DESCRIPTOR),			// bLength
		HID_DESC_TYPE,					// bDescriptorType
		0x0101,							// bcdHID
		0x00,							// bCountryCode
		0x01,							// bNumDescriptors
		REPORT_DESC_TYPE,				// bDescriptorType
		sizeof(HidReportDesc),			// wDescriptorLength
	},
	{		// Endpoint
		sizeof(ENDPOINT_DESCRIPTOR),	// bLength;		
		DESC_TYPE_ENDPOINT,				// bDescriptorType
		0x81,							// bEndpointAddress
		EP_TYPE_INTERRPUT,				// bmAttributes	
		8,								// wMaxPacketSize
		0x0a							// bInterval
	}
};


LANG_ID_DESC LangIDDesc=
{
	sizeof(LANG_ID_DESC),
	DESC_TYPE_STRING,
	0x0409				// en-US
};

STRING_PROD_DESC UnicodeProdDesc=
{
	sizeof(STRING_PROD_DESC),
	DESC_TYPE_STRING,
	'F','e','l','i','x','\'','s',' ','K','e','y','b','o','a','r','d'
};

STRING_VENDOR_DESC UnicodeVendorDesc=
{
	sizeof(STRING_VENDOR_DESC),
	DESC_TYPE_STRING,
	'c','r','u','e','l','s','t','u','d','i','o'
};

