#include "usb_stddesc.h"
#include "usb_hiddesc.h"

#define USB_MAX_EP0_SIZE		64	
/* 128 will NOT work, however */

// default, BUS powered, no remote-wakeup
#define DEV_CONFIG_ATTRIBUTES	0x80

// 50mA max
#define DEV_CONFIG_MAX_POWER	25

#define DEVICE_VID		0x8888
#define DEVICE_PID		0xA001
#define DEVICE_RELEASE	0x0101


#pragma pack(1)

typedef struct CONFIG_DESCRIPTOR_DATA_tag
{   
    CONFIG_DESCRIPTOR ConfigDesc;               // Configuration descriptor
	INTERFACE_DESCRIPTOR InterfaceDesc;
	HID_DESCRIPTOR HidDesc;
	ENDPOINT_DESCRIPTOR EndpDesc;
}CONFIG_DESCRIPTOR_DATA;


TYPEDEF_UNICODE_STRING_DESC(LANG_ID_DESC, 1);

#define STR_PRODUCT_NAME "Felix's Keyboard"

#define STR_VENDOR_NAME "cruelstudio"

TYPEDEF_UNICODE_STRING_DESC(STRING_PROD_DESC, sizeof(STR_PRODUCT_NAME)-1);
TYPEDEF_UNICODE_STRING_DESC(STRING_VENDOR_DESC, sizeof(STR_VENDOR_NAME)-1);

#pragma pack()
